figure

% M est le nombre de realisation de la base de generalisation
M=1000;
%
% generation d'une frontiere aleatoire
%
w_vrai=randn(N,1);
%
% generation de la base d'apprentissage
%
[Xapp,dapp]=genere_base_lineairement_separable(w_vrai,Papp);
%
% estimation de w
%
w_Hebb=discriminateur_Hebb(Xapp,dapp);
%
% calcul du taux de generalisation moyen
%
% vec_Pgen est un vecteur qui contient les differentes longueurs de base
% de gen considerees
%
vec_Pgen=[10 100 1000 10000];
%
for ind_Pgen=1:length(vec_Pgen)
    Pgen=vec_Pgen(ind_Pgen);
    vec_taux=zeros(1,M);
    %
    for m=1:M
        [X,d,Xgen,dgen]=genere_base_lineairement_separable(w_vrai,0,Pgen);
        vec_taux(m)=calcul_taux(Xgen,dgen,w_Hebb);
    end
    %
    % trace des histogrammes des valeurs de taux observees
    %
    subplot(2,2,ind_Pgen)
    histogram(vec_taux)
    %
    mu=mean(vec_taux);
    sigma=sqrt(var(vec_taux));
    %
    Titre=['moy. emp. = ' num2str(mu,3)...
        ', ecart-type emp. = ' num2str(sigma,3)...
        ];
    title(Titre)
    %
    xlabel(['P_{gen} = ' num2str(Pgen)])
    ylabel(['histo. de ' num2str(M) ' realisations de \tau_g'])
    set(gca,'fontsize',14)
    %
    drawnow
end
%
