function w=discriminateur_PI(X,d)
%
% w=discriminateur_PI(X,d);
%
% entrees
%========
% X : matrice de taille NxP contenant P vecteur
% d : vecteur colonne de taille P
%
% sorties
%========
% w : vecteur colonne de taille N
%
if size(X,1)<=size(X,2)
    w=(X*X.')\X*d;
else
    % On peut monter que calculer la pseudo-inverse :
    %w=pinv(X*X.')*X*d;
    % est equivalent  faire le calcul ci-dessous
    w=(X/(X'*X))*d;
    % qui permet d'aller plus vite.
end