function plot_base_de_donnee(X,vec_d)
%
% plot_base_de_donnee(X,d)
%
% entrees
%========
% X est une matrice de taille 3xP qui contient les differents vecteurs de
% la base
% d est un vecteur de taille P 

fontsize=16;
% variable d'initialisation
init=1;
%
%% variable qui contient les differentes couleurs
cell_couleur={'b','r','k','c','m','y','g'};
cell_forme={'o','x','+','*','s','d','^'};
%
N=size(X,1);
%
vec_unique_d=unique(vec_d);
c_max=min([length(cell_couleur) length(vec_unique_d)]);
%
for c=1:c_max
    couleur=cell_couleur{c};
    forme=cell_forme{c};
    d=vec_unique_d(c);
    %
    ind=find(vec_d==d);
    if ~isempty(ind)
        if N==2
            plot(X(1,ind),X(2,ind),[couleur forme])
        else
            plot3(X(1,ind),X(2,ind),X(3,ind),[couleur forme])
        end
        %
        if init==1
            hold on
            init=0;
            set(gca,'fontsize',fontsize)
            xlabel('x_1')
            ylabel('x_2')
        end
    end
end
%
